<?php
/*
Plugin Name: Facebook Fanbox Cache Widget
Plugin URI: http://www.electriceasel.com/plugins/wordpress/plugin-facebook-fan-box-cache
Description: Tired of FaceBook iFrame killing your load time, loading in 100+ images, 5+ CSS files, and 4+ JS files? Here's your answer - the Facebook Fanbox Cache Widget.
Version: 2.0
Author: Don Gilbert / ElectricEasel
Author URI: http://www.electriceasel.com/team-member/don-gilbert
License: GPLv2
*/


		
$GLOBALS['fbfbc_styles'] = array(
							"Inline (Requires Cache Refresh)" => 'inline',
							"Clean (Basic)" => "style_default.css",
							"Facebook Style" => "style_fb.css",
							"Disable" => NULL
						);

register_activation_hook( __FILE__, 'ee_fb_cache_activation');
function ee_fb_cache_activation() {
	if(version_compare(PHP_VERSION, '5.0.0', '<')) {
		wp_die('PHP version 5 or greater is required to use this plugin. You are running '. PHP_VERSION);
	}
}
add_action('admin_menu', 'ee_fb_create_menu');

function ee_fb_create_menu()
{
	add_options_page('FB Cache', 'FB Cache', 'manage_options', 'ee_fb_options', 'ee_fb_options_page');
	add_action('admin_init', 'ee_fb_settings');
}
function ee_fb_settings()
{
	register_setting('ee_fb_settings', 'fb_fanbox_id');
	register_setting('ee_fb_settings', 'fb_fanbox_limit');
	register_setting('ee_fb_settings', 'fb_fanbox_width');
	register_setting('ee_fb_settings', 'fb_fanbox_expire');
	register_setting('ee_fb_settings', 'fb_fanbox_css');
	if(get_option('fb_fanbox_css') == '') {
		update_option('fb_fanbox_css', 'inline');
	}
	if(get_option('fb_fanbox_width') == '') {
		update_option('fb_fanbox_width', '240px');
	}
	if(get_option('fb_fanbox_expire') == '') {
		update_option('fb_fanbox_expire', '3600');
	}
}
function ee_fb_options_page()
{ 
	global $fbfbc_styles;
	
	if($_POST['update'] == true) 
	{
	   if($_POST['fb_fanbox_width'] != get_option('fb_fanbox_width')
											   || $_POST['fb_fanbox_limit'] != get_option('fb_fanbox_limit')
											   || $_POST['fb_fanbox_id'] != get_option('fb_fanbox_id')
											   || $_POST['fb_fanbox_css'] != get_option('fb_fanbox_css')
											   || $_POST['fb_fanbox_expire'] != get_option('fb_fanbox_expire')
											   ) {
			$file = dirname(__FILE__).'/cache/fb_fanbox_cache_'.get_option('fb_fanbox_id').get_option('fb_fanbox_limit').'.html';
			if(file_exists($file))
				unlink($file);
		}
		if($_POST['fb_fanbox_clear'] == 'on')
		{
			$path = dirname(__FILE__).'/cache/';
			if($handle = opendir($path)) {
				while(false !== ($file = readdir($handle))) {
					if(preg_match("/fb_fanbox_cache_/", $file)) {
						unlink($path.$file);
					} 
				}
				$fb_msg = '<div class="updated settings-error" id="setting-error-settings_updated"><p><strong>Cached Fan Box files cleared.</strong></p></div>';
				closedir($handle);
			}
		}
	}
?>
<div class="wrap">
	<h2>Facebook Fanbox Cache</h2>
	<?php if($fb_msg) echo $fb_msg; ?>
	<p>Changing any of the settings below will clear the cache.</p>
	<form method="post" action="options.php">
    	<?php settings_fields( 'ee_fb_settings' ); ?>
    	<table class="form-table">
        	<tr valign="top">
        		<th scope="row">Facebook Page ID</th>
        		<td><input type="text" name="fb_fanbox_id" value="<?php echo get_option('fb_fanbox_id'); ?>" /></td>
        	</tr>
	        <tr valign="top">
    		    <th scope="row">Show Number of Connections</th>
        		<td><input type="text" name="fb_fanbox_limit" value="<?php echo get_option('fb_fanbox_limit'); ?>" /></td>
        	</tr>
	        <tr valign="top">
    		    <th scope="row">Set Default Width</th>
        		<td><input type="text" name="fb_fanbox_width" value="<?php echo get_option('fb_fanbox_width'); ?>" /> * In px - ie. 240px</td>
        	</tr>
	        <tr valign="top">
    		    <th scope="row">Cache Expiration</th>
        		<td><input type="text" name="fb_fanbox_expire" value="<?php echo get_option('fb_fanbox_expire'); ?>" /> * In seconds - ie. 3600 (3600 seconds - 1 hour)</td>
        	</tr>
	        <tr valign="top">
    		    <th scope="row">CSS Style</th>
        		<td><select name="fb_fanbox_css">
                <?
                foreach($fbfbc_styles as $name => $css)
                {
                    echo '<option value="'.$css.'" '.selected($instance['fanbox_css'], $css, false).'>'.$name.'</option>';
                }
				?>
                	</select>
                </td>
        	</tr>
		</table>
        <input type="hidden" name="update" value="true" />
    	<p class="submit">
    		<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
    	</p>
	</form>
    <form method="post" action="">
    	<table class="form-table">
        	<tr valign="top">
        		<th scope="row">Clear the cache?</th>
        		<td><input type="checkbox" name="fb_fanbox_clear" /> * Checking this box and clicking "Clear the Cache" will delete all cached fan box files.</td>
        	</tr>
        </table>
        <input type="hidden" name="update" value="true" />
    	<p class="submit">
    		<input type="submit" class="button-primary" value="<?php _e('Clear the Cache') ?>" />
    	</p>
	</form>
	<div class="css_guide">
	<h2>CSS Guide</h2>
	<p>For those who would like to disable inline css, you can copy and paste this into your themes style.css guide to get the default look.</p>
	<textarea style="width:500px;height:500px">
.widget_FBCache .fan_box {
	margin:10px auto;
	width:240px;
}
.widget_FBCache .fan_box_head {
	border-bottom:1px solid #D8DFEA;
	padding-bottom:5px;
}
.widget_FBCache .connections .total {
	font-size:12px;
}
.widget_FBCache .connections .grid a {
	float:left;
	text-align:center;
	text-decoration:none;
}
.widget_FBCache .connections .grid a img {
	margin:0;
	padding:5px 5px 0 5px;
}
.widget_FBCache .connections .grid a span {
	color:#808080;
	font-size:10px;
}
	</textarea>
	</div>
</div>
<?php }

add_shortcode('fanbox', 'ee_fb_shortcode');
function ee_fb_shortcode($atts)
{
	extract(shortcode_atts(array(
								 'id' => get_option('fb_fanbox_id'),
								 'limit' => get_option('fb_fanbox_limit'),
								 'width' => get_option('fb_fanbox_width'),
								 'expire' => get_option('fb_fanbox_expire'),
								 'css' => get_option('fb_fanbox_css')
								 ), $atts));
	$fb_fanbox_cache = new EE_FB_Fanbox_Cache($id, $limit, $width, $expire, $css);
	return $fb_fanbox_cache->write();
}

class EE_FB_Fanbox_Cache
{
	var $fanbox_ua = 'Mozilla/5.0';
	var $fanbox_css = NULL;
 
	protected $_html, $_fanCount = 0, $_fans = array(), $_pageInfo, $_output;
 
	public function __construct($id, $limit, $width, $expire, $css)
	{
		$this->fanbox_id = $id;
		$this->fanbox_limit = $limit;
		$this->fanbox_width = $width;
		$this->fanbox_time = time() - $expire;
		$this->fanbox_css = $css;
		
		$this->_getCacheFile();
		$this->_checkExpire();
		
		if($this->expired) {
			$this->_buildURL();
			$this->_getHTML();
		}
		if($this->fanbox_css)
		{
			add_action('wp_footer', array(&$this, 'add_style'));
		}
	}
	public function add_style()
	{
		wp_register_style('fbfbc', plugins_url('css/'.$this->fanbox_css, __FILE__));
		//wp_enqueue_styles('fbfbc');
		wp_print_styles('fbfbc');
	}
	public function write()
	{
		if($this->expired){
			$this->_parseHTML();
			$this->_buildOutput();
			$this->_writeOutput();
		}
		$html = file_get_contents($this->cachefile);
		echo $html;
	}
	private function _getCacheFile()
	{
		$this->cachefile = dirname(__FILE__).'/cache/fb_fanbox_cache_'.$this->fanbox_id.$this->fanbox_limit.'.html';
	}
	private function _getHTML()
	{
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_USERAGENT, $this->fanbox_ua);
		curl_setopt($ch, CURLOPT_URL, $this->fanbox_url);
		curl_setopt($ch, CURLOPT_FAILONERROR, TRUE);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$this->_html = curl_exec($ch);

		if ($this->_html === false) {
			throw new exception(curl_errno($ch) . ': ' . curl_error($ch));
		}
 
		curl_close($ch);
		$tmpfile = dirname(__FILE__).'/cache/fanbox.tmp.html';
		file_put_contents($tmpfile, $this->_html);
	}
	private function _checkExpire()
	{
		$this->expired = true;
		if(file_exists($this->cachefile))
			if(filemtime($this->cachefile) > $this->fanbox_time)
				$this->expired = false;
	}
	protected function _buildURL()
	{
		$fanbox_temp_url = 'http://www.facebook.com/plugins/fan.php?connections=';
		$fanbox_temp_url .= $this->fanbox_limit;
		$fanbox_temp_url .= '&id=';
		$fanbox_temp_url .= $this->fanbox_id;
		$fanbox_temp_url .= '&locale=en_US&stream=false&width=255';
		$this->fanbox_url = $fanbox_temp_url;
	}
	protected function _parseHTML()
	{
		$urlExp = '/<div class="connect_top clearfix"><a href="(.*?)" target="_blank">/';
		$nameExp = '/<span class="name">(.*?)<\/span>/';
		$fancountExp = '/<span class="total">(.*?)<\/span>/';
		$fanExp ='/<div class="grid_item">(<(a|span).*?<\/(a|span)>)<\/div>/';
		$pageExp ='/<div class="connect_top clearfix">(<a.*?<\/a>)/';
 
		preg_match($urlExp , $this->_html, $url);
		$this->_url = $url[1];
 
		preg_match_all($nameExp , $this->_html, $name);
		$this->_name = $name[1][0];
 
		preg_match_all($fancountExp , $this->_html, $fanCount);
		$this->_fanCount = $fanCount[1][0];
 
		preg_match_all($fanExp, $this->_html, $fans);
		$this->_fans = $fans[1];
 
		preg_match_all($pageExp, $this->_html, $pageInfoLink);
		$pageImageLink = str_replace(' target="_blank"', ' target="_blank" style="float:left;padding-right:5px;"', $pageInfoLink[1][0]);
		$pageImageLink = str_replace('img"', 'img" style="margin:0;padding:0" ', $pageImageLink);
		preg_match('/src="(.*?)"/', $pageImageLink, $pageImage);
		$imgfile = dirname(__FILE__).'/cache/'.$this->fanbox_id.'.jpg';
		file_put_contents($imgfile, file_get_contents($pageImage[1]));
		$oldimage = $pageImage[0];
		$newimage = 'src="'.plugins_url('/cache/'.$this->fanbox_id.'.jpg', __FILE__).'"';
		$pageImageLink = str_replace($oldimage, $newimage, $pageImageLink);
		$this->_pageImageLink = $pageImageLink;
		
	}
	protected function _buildOutput()
	{
		$vars = array(
					  'url'=>$this->_url,
					  'name'=>$this->_name,
					  'count'=>$this->_fanCount,
					  'fans'=>$this->_fans,
					  'pageimagelink'=>$this->_pageImageLink,
					  'width'=>$this->fanbox_width
					  );
		if($this->fanbox_css == "inline") {
			$output  = '<div class="fan_box" style="width:'. $vars['width'] .';margin:10px auto;">' . "\r\n";
				$output .= "\t" . '<div class="fan_box_head" style="border-bottom:1px solid #D8DFEA;padding-bottom:5px;">' . "\r\n";
					$output .= "\t\t" . $vars['pageimagelink'] . "\r\n";
					$output .= "\t\t" . '<div class="fan_box_name">' . "\r\n";
						$output .= "\t\t\t" .'<span style="font-size:16px;">'. $vars['name'] .'</span> on Facebook' . "\r\n";
					$output .= "\t\t" . '</div>' . "\r\n";
					$output .= "\t\t" . '<div class="connect_button">' . "\r\n";
						$output .= "\t\t\t" .'<a href="'.$vars['url'].'" target="_blank" class="FBbutton_Text">Become a Fan</a>';
					$output .= "\t\t" . '</div>' . "\r\n";
					$output .= "\t\t" . '<div style="clear:both;"></div>' . "\r\n";
				$output .= "\t" . '</div>' . "\r\n";
				$output .= "\t" . '<div class="connections">' . "\r\n";
					$output .= "\t\t" . '<div class="total" style="font-size:12px;">' . "\r\n";
						$output .= "\t\t\t" . $vars['count'] . "\r\n";
					$output .= "\t\t" . '</div>' . "\r\n";
					$output .= "\t\t" . '<div class="grid">' . "\r\n";
						foreach ($vars['fans'] as $fan) {
							preg_match('/<div class="name">(.*?)<\/div>/', $fan, $fanname);
							preg_match('/src="(.*?)"/', $fan, $fan_image_url);
							$file = dirname(__FILE__).'/cache/'.$fanname[1].'.jpg';
							file_put_contents($file, file_get_contents($fan_image_url[1]));
							$oldimage = 'src="'.$fan_image_url[1].'"';
							$image = 'src="'.plugins_url('/cache/'.$fanname[1].'.jpg', __FILE__).'"';
							$fan = str_replace($oldimage, $image, $fan);
							$fan = str_replace(' class="img"', ' style="padding:5px 5px 0 5px;margin:0px;" alt="'.$fanname[1].'"', $fan);
							$fan = str_replace('<div class="name"', '<br /><span style="font-size:10px;color:#808080"', $fan);
							$fan = str_replace('/div', '/span', $fan);
							$fan = str_replace(' target="_blank"', ' target="_blank" style="text-align:center;float:left;"', $fan);
							$output .= "\t\t\t" . $fan . "\r\n";
						}
					$output .= "\t\t" . '<div style="clear:both;"></div>' . "\r\n";
					$output .= "\t\t" . '</div>' . "\r\n";
				$output .= "\t" . '</div>' . "\r\n";
			$output .= '</div>';
		} else {
			$output  = '<div class="fan_box">' . "\r\n";
				$output .= "\t" . '<div class="fan_box_head">' . "\r\n";
					$output .= "\t\t" . $vars['pageimagelink'] . "\r\n";
					$output .= "\t\t" . '<div class="fan_box_name">' . "\r\n";
						$output .= "\t\t\t" .'<span>'. $vars['name'] .'</span> on Facebook' . "\r\n";
					$output .= "\t\t" . '</div>' . "\r\n";
					$output .= "\t\t" . '<div class="connect_button">' . "\r\n";
						$output .= "\t\t\t" .'<a href="'.$vars['url'].'" target="_blank" class="FBbutton_Text">Become a Fan</a>';
					$output .= "\t\t" . '</div>' . "\r\n";
					$output .= "\t\t" . '<div style="clear:both;"></div>' . "\r\n";
				$output .= "\t" . '</div>' . "\r\n";
				$output .= "\t" . '<div class="connections">' . "\r\n";
					$output .= "\t\t" . '<div class="total">' . "\r\n";
						$output .= "\t\t\t" . $vars['count'] . "\r\n";
					$output .= "\t\t" . '</div>' . "\r\n";
					$output .= "\t\t" . '<div class="grid">' . "\r\n";
						foreach ($vars['fans'] as $fan) {
							preg_match('/<div class="name">(.*?)<\/div>/', $fan, $fanname);
							preg_match('/src="(.*?)"/', $fan, $fan_image_url);
							$file = dirname(__FILE__).'/cache/'.$fanname[1].'.jpg';
							file_put_contents(dirname(__FILE__).'/cache/'.$fanname[1].'.jpg', file_get_contents($fan_image_url[1]));
							$oldimage = 'src="'.$fan_image_url[1].'"';
							$image = 'src="'.plugins_url('/cache/'.$fanname[1].'.jpg', __FILE__).'"';
							$fan = str_replace($oldimage, $image, $fan);
							$fan = str_replace(' class="img"', '  alt="'.$fanname[1].'"', $fan);
							$fan = str_replace('<div class="name"', '<br /><span', $fan);
							$fan = str_replace('/div', '/span', $fan);
							$output .= "\t\t\t" . $fan . "\r\n";
						}
					$output .= "\t\t" . '<div style="clear:both;"></div>' . "\r\n";
					$output .= "\t\t" . '</div>' . "\r\n";
				$output .= "\t" . '</div>' . "\r\n";
			$output .= '</div>';
		}
		$this->_output = $output;
	}
	protected function _writeOutput()
	{
		file_put_contents($this->cachefile, $this->_output);
	}
}

class EE_FB_Fanbox_Cache_Widget extends WP_Widget {
	function EE_FB_Fanbox_Cache_Widget() {
		$widget_ops  = array(
							 'classname' => 'widget_FBCache',
							 'description' => __( "Facebook Fan Box Widget (Cached)" )
							 );
		$this->WP_Widget('fbCache', __('FB Cache'), $widget_ops);
	}
	function widget($args, $instance) {
		extract($args);
		echo $before_widget;
		if(!empty($instance['title'])) {
			echo $before_title . $instance['title'] . $after_title;
		}
		echo ee_fb_shortcode(array(
								   'id'=>$instance['fanbox_id'],
								   'limit'=>$instance['fanbox_limit'],
								   'width'=>$instance['fanbox_width'],
								   'expire'=>$instance['fanbox_expire'],
								   'css'=>$instance['fanbox_css']
								   )
							 );
		echo $after_widget;
	}
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
	function form($instance) {
		global $fbfbc_styles;
		
		echo '<div id="myFavoritesWidget-admin-panel">';
		echo '<label for="' . $this->get_field_id("title") . '">Title:</label><br />';
		echo '<input type="text" class="widefat" ';
		echo 'name="' . $this->get_field_name("title") .'" ';
		echo 'id="' . $this->get_field_id("title") .'" ';
		echo 'value="' . $instance['title'] . '" /><br />';
		echo '<label for="' . $this->get_field_id("fanbox_id") . '">Fanbox ID:</label><br />';
		echo '<input type="text" class="widefat" ';
		echo 'name="' . $this->get_field_name("fanbox_id") .'" ';
		echo 'id="' . $this->get_field_id("fanbox_id") .'" ';
		echo 'value="' . $instance['fanbox_id'] . '" /><br />';
		echo '<label for="' . $this->get_field_id("fanbox_limit") . '">Limit:</label><br />';
		echo '<input type="text" class="widefat" ';
		echo 'name="' . $this->get_field_name("fanbox_limit") .'" ';
		echo 'id="' . $this->get_field_id("fanbox_limit") .'" ';
		echo 'value="' . $instance['fanbox_limit'] . '" /><br />';
		echo '<label for="' . $this->get_field_id("fanbox_width") . '">Width:</label><br />';
		echo '<input type="text" class="widefat" ';
		echo 'name="' . $this->get_field_name("fanbox_width") .'" ';
		echo 'id="' . $this->get_field_id("fanbox_width") .'" ';
		echo 'value="' . $instance['fanbox_width'] . '" /><br />';
		echo '<label for="' . $this->get_field_id("fanbox_expire") . '">Expiration:</label><br />';
		echo '<input type="text" class="widefat" ';
		echo 'name="' . $this->get_field_name("fanbox_expire") .'" ';
		echo 'id="' . $this->get_field_id("fanbox_expire") .'" ';
		echo 'value="' . $instance['fanbox_expire'] . '" /><br />';
		echo '<label for="' . $this->get_field_id("fanbox_css") . '">CSS Style:</label><br />';
		echo '<select ';
		echo 'name="' . $this->get_field_name("fanbox_css") .'" ';
		echo 'id="' . $this->get_field_id("fanbox_css") .'"> ';
		foreach($fbfbc_styles as $name => $css)
		{
			echo '<option value="'.$css.'" '.selected($instance['fanbox_css'], $css, false).'>'.$name.'</option>';
		}
		echo '</select><br />';
		echo '<p>This widget will display a cached version of your facebook fanbox that refreshes based on your expiration setting.</p>';
		echo '</div>';
	}
}
add_action('widgets_init', create_function('', 'return register_widget("EE_FB_Fanbox_Cache_Widget");'));

